//: typslova

#define OBJWORD  -2
#define LANGWORD -1
#define STDWORD   0

//: vetnyclen

struct vetnyclen{
  char jekat;
  union{
    struct slovo *presneslovo;
    int *kateg;
  } u;
  int mistoparam;
};

//: veta

struct veta{
  void (*funkce)(int, kq_word **);
  int pocetclenu, pocetparam;
  struct vetnyclen *cleny;
  struct veta *next;
} *jenkat;

//: slovo

struct slovo{
  int pocet;
  char makro;
  int *kateg;
  union{
    kq_list *nahradit;
    struct veta *vety;
  } u;
  kq_word *ulozeno;
};

//: kq_word

struct kq_word{
  kq_pin informace;
  char info2;
  int cislo;

  char kontext, loaded_kontext;
  char *nazev;
  kq_word *next;
};

kq_word *prvulslovo, *aktulslovo;
int pocet_word;

//: prototypy

kq_word *add_word(char kontext);
void add_sent(void (*f)());
void finishws();

void warneznam(char *slovo);
void popwarneznam(char *slovo);

void nactiinput(char *jazyk);
void wordtohash(struct slovo *w, char *str);

kq_list *rozeberstr(char *str, void (*neznam)());
void expandvetu(kq_list **veta);
char provedvetu(struct slovo **slova);
char provedstr(char *str);
