\subsec Deifrovn inputu

Tento modul e pevod stringu, kter hr nape, na uritou funkci
s uritmi parametry. Tato urit funkce pak provede vznam napsan
vty. Tuto konverzi provede funkce \dg [void] provedstr()

\ins c provedstr

Nejprve je string pemnn na "kq_list" ukazatel na strukturu
\dg [struct] slovo funkc "rozeberstr".

\ins h slovo

Prvn poloka tto struktury je "typ", ta me nabvat t hodnot:

\ins h typslova

S typem souvis poloka "u". Kdy typ je \dg SLOVO, tak se jedn o
zkladn slovo. Seznam bude postupn upravovn tak, e nakonec budou
vechna slova mt typ slovo.

Pokud "typ == SLOVO", pak je uloena
informace v poloce "u.vety", pokud "typ == MAKROSL", pak je uloena
informace v poloce "u.nahradit" a pokud "typ == SYNONYM", pak je
uloena informace v poloce "u.puvodni". Dle tam jsou poloky "kateg"
a "uloeno". V poloce "ulozeno" je odkaz na "kq_word", kde jsou daje
o slov pro funkci, kter se nakonec spust. Tato poloka tak me
bt NULL. V takovm ppad by se slovo do tto funkce nemlo dostat.
V poloce "kateg" je pole kategori, pod kter toto slovo spad, co
uruje, do kterch vt se slovo hod a do kterch ne.

Funkce \dg [kq_list *]rozeberstr() dostane string a
funkci, kterou m zavolat, kdy njak slovo nepochop. Nejprve si
string zduplikuje a aplikuje na nj funkci "upravstring", m
zajist, e v~textu nebudou pebyten mezery, velk psmena a dal
podivn znaky. Pak si pete slovo a po prvn mezeru a vyhled ho v
hashi pod dvma typy. Zjist jednak, zda jde o slovo (typ "WORD") a
tak, zda jde o st slova (typ "WORDPART"). Pokud zjist, e to je
st slova, zkus do tohoto slova pidat dal sek textu po dal
mezeru. Jakmile to st slova nen nebo naraz na konec stringu,
sebere ze stringu posledn nalezen slovo a do listu pid pointer z
nlezu tohoto slova v~hashi. Pokud ovem toto je slovo typu \dg SYNONYM,
nahrad ho slovem v~poloce "u.puvodni" tohoto slova.

\ins c rozeberstr

Na tento list je pak aplikovna funkce \dg [void] expandvetu(), kter vechna
slova  typu \dg MAKROSL nahrad skupinou slov v poloce "u.nahradit".
Po proveden tto funkce u maj vechna slova typ "SLOVO".

\ins c expandvetu

Nakonec je list peveden na pole, na kter se zavol funkce
\dg [void] provedvetu().

Tato funkce nejprve zkontroluje, zda se ve vt nenachz slovo mimo
kontext. To je takov slovo, ve kterm "ulozeno->kontext = 0". Potom
hled vtu, kter je kompatibiln s polem kter dostala.

Vtu zastupuje ukazatel na \dg [struct] veta, tato struktura
vypad nsledovn:

\ins h veta

Aby bylo mono mezi vtami vyhledvat, jsou azeny do seznam, kde jsou
propojeny pes poloky "next". Dle je zde pole "cleny", jeho dlku
udv poloka "pocetclenu" a struktura \dg [struct] vetnyclen
vypad nsledovn:

\ins h vetnyclen

Poloka typ me bt "SLOVO" nebo \dg KATEG.

\ins h typkateg

Pokud "typ = SLOVO", mus bt na danm mst slovo stejn jako
v~poloce "u.presneslovo". Pokud "typ == KATEG", mus bt mezi polem
"u.kateg" a polem kategori ve slov na onom mst neprzdn
prnik. Pole "u.kateg" je ukoneno nulou.

Abych pi vyhledvn sprvn vty nemusel prohledat vechny, mm
seznamy vt roztdn podle prvnho vtnho lenu s typem
"SLOVO". Vdy pi vytvoen vty je tedy vyhledn prvn takov vtn
len a pak je vta pidna do seznamu v poloce "u.vety" toho
slova. Pokud nem vta dn vtn len typu "SLOVO", je pidna do
globlnho seznamu vt \d jencat.

Pi hledn vty jsou nejprve prohledny vty prvnho slova, pak vty
druhho slova, ..., a vty poslednho slova a nakonec je prohledn
seznam "jenkat".

Po t, co je vta nalezena, je teba si pipravit pole
parametr. Vytvo se pole pointer na "kq_word" tak velik, jak udv
poloka pocetparam dan vty a cel se pronuluje. Pak se prochz
vtn leny a kad vtn len, jeho "mistoparam" je nezporn udv
index do toho pole, kam se m dan vtn len nahrt. Konkrtn se nam
zkopruje poloka "ulozeno" pslunho slova. Nakonec je sputna
"funkce" nalezen vty s dvma parametry. Prvn je dlka pole neboli
"pocetparam" a druh je to pole.

\ins c provedvetu

\subsec Syntaxe jazyka inputu

Ve zmnn datov struktury se mus njakm zpsobem naplnit. st
informac je nateno ze souboru, take je mon zmnou natanho
souboru zmnit jazyk, kterm budeme s pankem hovoit. V souboru jsou
ignorovny znaky kter nejsou v sekci slov ani vt. Tyto sekce se
mohou opakovat. Sekce slov zan stringem "words{" na zatku dku a
kon zavrac svorkatou zvorkou. Sekce vt zan stringem
"sentences{" za zatku dku a kon tak zavrac zvorkou.

Pi ten souboru Me program narazit na backshlash nebo
procento. Procento zru veker text (vetn backshlash a zavracch
zvorek) a po konec dku, ale ponech enter. Backshlash se pouv
pro zamaskovn enteru, ili {\langleactive "\ <enter>"} se promni v
mezeru. Dvojice "\\" se promn v jeden backshlash. Pokud je za
backshlashem procento, tak se nejprve aplikuje procento, kter po sob
zanech enter, ten je pak backshlashem promnn v mezeru. Ve vech ostatnch
ppadech backshlash jen zmiz sm sebe a mezery, co jsou za nm.

Kad slovo i kad vta odpovd jednomu neprzdnmu dku v sekci
slov nebo vt. Nejjednodu deklarace vty je pmo napsan
vta. Vty maj ovem takov omezen, e nemohou mt mce ne 26
len, tedy slov. Kad slovo z tto vty mus bt dve deklarovno v sti
slov. Vce mezer se promni v jednu mezeru a mezery na krajch dku
jsou ignorovny. Za mezeru je povaovn i jin znak, kter nen
psmeno a nen jinak zpracovn. Nejjednodu pklad takovho souboru
tedy vypad takto:

\begtt
words{
  jdi
}
sentences{
  jdi
}
\endtt

V inicializan sti hlavnho programu (tj. mezi "kql_init" a
"kql_start") by pak mla bt zavolna funkce "add_sent" s parametrem
pointer na funkci, kter se m pi zavoln t vty provst. Pokud
bude v souboru vce vt, ml by bt ve zdrojku stejn poet voln
funkce "add_sent" a jednotliv funkce budou pak piazeny dkm vt
ve stejnm poad. Na dku v sekci vt me bt stednk, kter
jakoby zalo nov dek vty, ale pro funkci "add_sent" se tv
stle jako jeden dek, tedy vem vtm oddlenm stednkem je
piazena stejn funkce. Podobn se daj stednkem oddlovat
slova. Jak je rozdl mezi slovy oddlenmi stednkem a oddlenmi
enterem vysvtlm pozdji. Zatm rozdl nen dn.

\begtt
words{
  jdi; zastav; se; stj;
}
sentences{
  jdi
  zastav se; stj
}
\endtt

Ve zdrojku by pak mlo bt nco jako:

\begtt
add_sent(&chod);
add_sent(&stuj);
\endtt

Slova mohou bt typu synonymum, kter se okamit promn v pvodn
slovo. Synonyma se vytvo tak, e se na dku (stednk tak oddluje
dky) se slova oddl rkami. Tm se prvn slovo stane pvodnm
slovem a ostatn v tomto dku synonymy, kter se v nj promn. rky
se daj uzavt do kulatch zvorek. Tm se okol zvorek zkopruje a
ze vnitku se vdy vybere jedna monost. Napklad

\begtt
velk (pn, lovk, mu)
\endtt

expanduje na

\begtt
velk pn, velk lovk, velk mu
\endtt

Mezery jsou odstraovny a po expanzi, take nen teba eit
napklad dv mezery mezi "velk" a "lovk". Pokud ovem napete

\begtt
papr(ek, eek)
\endtt

neexpanduje to na "paprek" a "papreek", ale na

\begtt
paprek, papr eek
\endtt

Msto kulatch zvorek se tak daj pout zvorky hranat, kter
oznauj nepovin text. Maj tedy stejn vznam jako kdy by na
zatku kulatch zvorek byla rka. Zvorky mohou 

Dal pklad: dky

\begtt
[toho] (pna, lovka, mue)
shrek, [[hrkov, pern] zelen] [zl]obr 
\endtt

expanduj na

\begtt
pna, lovka, mue, toho pna, toho lovka, toho mue
shrek, obr, zlobr, zelen obr, zelen zlobr, hrkov zelen obr,    \
   hrkov zelen zlobr, pern zelen obr, pern zelen zlobr
\endtt

Kdy je na dku slova rovntko, tak se deklarovan slovo stane
makroslovem, kter se nahrad slovy, co jsou za rovntkem. Tato slova
u mus bt deklarovan a pokud zde jsou makroslova, jsou
expandovna. Neme se tedy stt, aby bylo makroslovo uvnit
makroslova.

Je dobr definovat vatu jako makroslovo, kter expanduje na nic. Dle
jsem zjistil, e se makroslovo hod pro slovo "prozkoumej", kter
expanduje na dv slova: "koukni" a "na".

Vrtme se zpt k deklaraci vty. Pokud je na dku s vtou rka, za
n jsou napsny varianty, jak mohou bt uspodny slova tto vty
pomoc psmenek. Prvnmu slovu je piazeno psmeno "a", druhmu
psmeno "b", tetmu "c", ... Jsou-li ve vt makroslova, je psmeno
piazen celmu makroslovu a expanze probhne a pozdji. Jednotliv
uspodn jsou oddlena rkami a jsou v nich ignorovny mezery. Jin
znaky by se tam nemly vyskytovat. Kdy u jsou ve vt takovto
poad, nen platn pvodn poad. Nemus bt pouita vechna
psmenka.

Pklad:

\begtt
words{
  ukoni; program; v klidu
}
\sentences{
  program v klidu ukoni, bca, cba, acb, ca
}
\endtt

Funguje stejn jako kdyby v sekci vt bylo napsno:

\begtt
  v klidu ukoni program; ukoni v klidu program;\
     program ukoni v klidu; ukoni program
\endtt

...

\subsec Interpretace natn inputu

...