#include "kraluk.h"

static void jezinsmer(int *xx, int *yy)
{
  *yy += *xx;
  *xx -= *yy-*xx;
  if(!*xx || !*yy){
    *xx /= 2;
    *yy /= 2;
  }
}

void prich_jezin (kq_policko *opol, int smer, kq_policko *npol)
{
  int i, x, y, xx, yy;
  kq_animpost *anip;
  kq_postava *jezinka;

  if(smolicek->kontext <= 0){
    znak = 'x';
    return;
  }

  osoba->kontext++;
  vytvorwidget(81, 64, 63.2, nactikqXPM("smolicek", 1), 1, 0);
  xx = 1;
  yy = 0;
  x = 32;
  y = 26;
  anip = nactianip(9, 40, "jezinka", 4, 0, 0, 0, 1);
  for(i=0; i<8; i++){
    jezinka = vytvorpost(x, y, DOLU, 3, -1, 1, 0);
    jezinka->xx = xx;
    jezinka->yy = yy;
    autopost(jezinka, auto_jezin, 75, 75);
    zmenanip(jezinka, anip);
    normal_z(jezinka, NULL, NULL);
    jezinka->chyt_vzdal = 7;
    jezinka->chyt_func = jezin_chyt;
    setchytpost(jezinka, panacek);

    x += 25*xx;
    y += 25*yy;
    jezinsmer(&xx, &yy);
  }
}

void auto_jezin (kq_postava *post)
{
  jezinsmer(&post->xx, &post->yy);
}

void jezin_chyt (kq_postava *post)
{
  popup_info("chytila jezinka");
  posunpost(panacek, 44, 84);
  panacek->xx = panacek->yy = 0;
  panacek->smer = DOLU;
}

void prich_jelen (kq_policko *opol, int smer, kq_policko *npol)
{
  if(jelen->kontext <= 0){
    znak = 'x';
    return;
  }

  jinapost = vytvorpost(19, 57, NAHORU, 0, -1, 1, 0);
  normal_z(jinapost, NULL, NULL);
  zmenanip(jinapost, nactianip(17, 71, "jelen", 4, 0, 1, 0, 1));
  post_submap(jinapost, "jelen", 16, 7, 5);
  jinapost->free_func = null_jp;
  jinapost->tim = vytvortimer(jelen_step, pinnull, 3, -1, 0, 1, 0);
}

void jelen_step ()
{
  if(jinapost->smer == NAHORU) jinapost->animstav++;
  else jinapost->animstav--;

  if(jinapost->animstav == 0){
    jinapost->smer = NAHORU;
    aktutimer->zbyva = 50;
  }
  else if(jinapost->animstav == 3){
    jinapost->smer = DOLU;
    aktutimer->zbyva = 50;
  }
  zmenapost(jinapost);
}
