#include "kraluk.h"

static void vytvor_krk (int x, int y, kq_animpost *anip)
{
  kq_postava *post;

  post = vytvorpost(x, y, DOLU, 0, 0, 1, 0);
  zmenanip(post, krksedi);
  normal_z(post, NULL, NULL);
  post->barvy = post->zdi = 0;
}

void prich_krk (kq_policko *opol, int smer, kq_policko *npol)
{
  kq_animpost *anip;

  if(krkavci->kontext <= 0){
    znak = 'x';
    return;
  }

  krksedi = nactianip(7, 73, "krksedi", 1, 0, 1, 0, 1);
  krkleti = nactianip(7, 93, "krkleti", 2, 4, 0, 1, 1);

  vytvor_krk(14,  46, anip);
  vytvor_krk(25,  67, anip);
  vytvor_krk(37,  85, anip);
  vytvor_krk(53, 101, anip);
  vytvor_krk(69,  84, anip);
  vytvor_krk(81,  63, anip);
  vytvor_krk(92,  50, anip);

  vytvortimer(plasptaky, pinnull, 10, 0, 0, 1, 0);
}

void prich_bohd (kq_policko *opol, int smer, kq_policko *npol)
{
  if(!krkstav){
    znak = 'z';
    return;
  }

  if(krkstav > 0){
    vytvorwidget( 81, 102, 95.2, nactikqXPM("smutnab", 1), 1, 0);
    osoba->kontext++;
    divka->kontext++;
    bohdanka->kontext++;
  }
  else{
    znak = 'o';
    vytvorwidget(124, 88, 90.2, nactikqXPM("otvchaldrev", 1), 1, 0);
    vytvorsubmap( 64, 90, 15, "dodrchal", 1, 0);
  }
}

void odch_bohd (kq_policko *opol, int smer, kq_policko **npol, int *x, int *y)
{
  if(krkstav > 0){
    osoba->kontext--;
    divka->kontext--;
    bohdanka->kontext--;
  }
}

void plasptaky ()
{
  kq_postava *pom;

  for(pom = prvpost; pom; pom = pom->next)
    if(pom != panacek){
      if(pom->chyt_func){
	znictimer(aktutimer);
	return;
      }
      if(post_vzdal(pom, panacek) < 20) zmenanip(pom, krkleti);
      else zmenanip(pom, krksedi);
    }
}

void promenujkrk ()
{
  kq_postava *pom;

  odkrk = nactianip(9, 40, "odkrk",   8, 0,  1, 0, 0);
  krkstav = -1;

  krkleti->y = 73;
  for(pom = prvpost; pom; pom = pom->next)
    if(pom != panacek){
      setchytsour(pom, panacek->x, panacek->y);
      pom->chyt_func = krk_chyt;
      zmenanip(pom, krkleti);
      autopost(pom, auto_primo, 0, 0);
      pom->tim = vytvortimer(jdipost, pinpointer(pom), 3, -1, 0, 1, 0);
    }

  popup_info("promen krk");
}

void krk_chyt (kq_postava *post)
{
  krkavci->kontext--;
  zmenanip(post, odkrk);
  post->xx = 1;
  post->yy = 0;
  autopost(post, NULL, 0, 0);
}

void zdrchal (kq_policko *opol, int smer, kq_policko **npol, int *x, int *y)
{
  *x -= 5;
  *y = 91;
}

void null_krk (kq_policko *opol, int smer, kq_policko **npol, int *x, int *y)
{
  odkrk = krkleti = krksedi = NULL;
}
