#include <stdlib.h>
#include "types.h"
#include "list.h"

//: smazlist

void smazlist (kq_list **l)
{
  kq_list *pom;

  while(*l){
    pom = (*l)->next;
    free(*l);
    *l = pom;
  }
  *l = NULL;
}

//: adddoL

void addPdoL (void *p, kq_list **l)
{
  kq_list *pom;

  pom = (kq_list *)malloc(sizeof(kq_list));
  pom->u.p = p;
  pom->next = *l;
  *l = pom;
}

void addIdoL (int i, kq_list **l)
{
  kq_list *pom;

  pom = (kq_list *)malloc(sizeof(kq_list));
  pom->u.i = i;
  pom->next = *l;
  *l = pom;
}

//: delkaL

int delkaL (kq_list *l)
{
  int vysledek;

  for(vysledek = 0; l; l = l->next) vysledek++;

  return vysledek;
}

//: LdoA

void **LdoPA (kq_list *l)
{
  int i;
  void **vysledek;

  i = delkaL(l);
  vysledek = (void **)malloc((i+1)*sizeof(void *));

  vysledek[i] = NULL;
  for(;l; l = l->next) vysledek[--i] = l->u.p;

  return vysledek;
}

int *LdoIA (kq_list *l)
{
  int i;
  int *vysledek;

  i = delkaL(l);
  vysledek = (int *)malloc((i+1)*sizeof(int));

  vysledek[i] = 0;
  for(;l; l = l->next) vysledek[--i] = l->u.i;

  return vysledek;
}
