Modul loop obsahuje funkci "loop()" a pr dalch s ktermi tato
funkce souvis. Funkce \dg [void] loop() je sputn na startu a od t
doby b a spout dal funkce. Bhem jednoho svho cyklu tato
funkce udl nsledujc:

\begitems
\item1) Zpracuje nov udlosti.
\item2) Provede timery a posune je o jedniku.
\item3) Provede grafick zmny.
\item4) Pok pedem uren as.
\enditems

V tom ekn je mal hek, protoe hardware nen schopn ekat tak
dlouho, jak chci, ale jen po nsobcch uritho minimlnho
asu. Abych tedy nebyl omezen njakou maximln rychlost, kontroluji
kad frame, jak se li as, kter ml ekat a as, kter ve
skutenosti ekal. Pokud ekal $x$-krt del ($x>1$) dobu nez ml, pustm
bez ekn $x$ fram. Napklad pokud po nm chci, aby ekal 2 sekundy
a on ek 10 nebo 11 sekund, peskom tyikrt dost o
ekn. Pokud by ale ve skutenosti ekal jednu nebo ti sekundy, nic
nepeskakuji. Nen to sice zcela pesn, ale alespo nejsem omezen
maximln rychlost.

\ins c loop

Do globln promnn \dg [char] cekalose ulom true, pokud je vhodn
peskakovn fram peruit, Dal frame je do promnn cekalose opt
uloen false. Na true se nastavuje napklad kdy mnm rychlost nebo
pepnu do textovho mdu. Do lokaln promnn "opakovani" ukldm,
kolikrt jet chci peskoit ekn. Pokud nic nepeskakuji, je
v~"opakovani" nula.

Ve funkci "loop" volm funkci \dl [void] udalosti() pro zpracovn
udlost. Tato funkce projde vechny zafrontn udlosti a pokud je
pak oznaen text, nevypne se a ek na udlosti, dokud se opt
neozna zptky hlavn oknko s obrzky.

\ins c udalosti

as, kter chci ekat, je uloen v promnnch \dl [int] vter a \dl
[int] uvter. V~promnn "vter" je poet sekund, kter se m ekat a
v~promnn "uvter" zbyvajc poet mikrosekund. Tento ekajc as se
d zmnt pomoc funkce \dg [void] setdelay(), kter dostane poet
sekund a mikrosekund a tento as do promnnch "vter" a "uvter",
piem nejprve pevede parametry do jednoho sla a pak opt
rozlo.

\ins c setdelay

Pomoc funkce \dg [void] setFPSs() vytvom pole \dg [double] FPSs
rychlost, kter budou ve he dostupn. Tato funkce m promnn poet
parametr, take kompiltor nepozn, jak je typ parametr. Je proto
teba u~kadho parametru (krom prvnho) zdraznit, e je typu
double, napklad tm, e se za nj nape desetin teka. Seznam
parametr je ukonen nulou a zporn parametr bude naten jako
aktuln rychlost (FPS). V promnn \dg [int] aktuFPS je index do pole
"FPSs" pro aktuln rychlost. Promnn \dg [int] maxFPS udv index na
posledn polko pole "FPSs" tedy jeho dlka minus jedna.

\ins c setFPSs

Pro zmnu aktuln rychlosti se d pout funkce \dg [void] zmenFPS(). Jejm
parametrem je hodnota, kter se pite k promnn "aktuFPS".

\ins c zmenFPS